function [sys,x0,str,ts] = xyplotting(t,x,u,flag,n,in)
% S-function with one external parameter : number of trays in the column

h=figure(1);
global movorgif
movorgif=1; % 0=movie, 1=animated gif
%
% Dispatch the flag.
%
switch flag,
  case 0
    [sys,x0,str,ts]=mdlInitializeSizes(h,n,in); % Initialization
  case 2
    sys = mdlUpdate(t,x,u,h,n,in);
  case 9
    sys = mdlTerminate(t,x,u);
  case { 1, 3, 4 } % Unused flags
    sys = [];
  otherwise
    error(['Unhandled flag = ',num2str(flag)]); % Error handling
end
% End of csfunc.
%==============================================================
% mdlInitializeSizes
% Return the sizes, initial conditions, and sample times for the 
% S-function.
%==============================================================
%
function [sys,x0,str,ts] = mdlInitializeSizes(h,n,in)
%
% Call simsizes for a sizes structure, fill it in and convert it 
% to a sizes array.
%
sizes = simsizes;
sizes.NumContStates  = 0;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 0;
sizes.NumInputs      = in*n;
sizes.DirFeedthrough = 0;
sizes.NumSampleTimes = 1;
sys = simsizes(sizes);
%
% Initialize the initial conditions.
%
x0 = [];
str = [];
ts = [1 0];
%
% Plot initial function
%
set(h,'name','column profile');
clf;
hold on, 
p=get(h,'Currentaxes');
set(p,'Xlim',[0.5, n+0.5]);
set(p,'Ylim',[0, 1]);


global NextT deltaT
deltaT=100;
NextT=0;

global movorgif
% if movorgif==0,
%     global aviobj
%     aviobj = avifile('neurone3.avi')
%     aviobj.Compression = 'None';
%     aviobj.Quality = 100;
%     frame = getframe(gca);
%     aviobj = addframe(aviobj,frame);
% else
%     global gifn
%     gifn=1;
    %print('-dbmp',['kyotofigs\fig',di(gifn,3),'.bmp'])
% end,
% End of mdlInitializeSizes.
%
%==============================================================
% mdlDerivatives
% Return the derivatives for the continuous states.
%==============================================================
function sys = mdlUpdate(t,x,u,h,n,in)
p=get(h,'CurrentAxes');pp=get(p,'Children');
for i=1:length(pp)
    delete(pp(i)),
end
abs=[1:n];
if in==1
    prof=u(1:n)';
    plot(abs,prof,'r-','LineWidth',1),
else
    Cprof=u(1:n)';
    Eprof=u(n+(1:n))';
    plot(abs,Cprof,'r-','LineWidth',1)
    plot(abs,Eprof,'b-','LineWidth',1)
end,


% p=get(h,'CurrentAxes');pp=get(p,'Children');
% for i=1:length(pp),
%     if isequal(get(pp(i),'type'),'line'),
%         c=get(pp(i),'color');
%         if c(3)==1,% i.e. ligne bleue
%             ms=get(pp(i),'MarkerSize');
%             if ms>1e-8,
%                 set(pp(i),'MarkerSize',0.5*ms),
%             else
%                 delete(pp(i)),
%             end,
%         end,
%     end,
% end,







% global NextT deltaT
% if t>=NextT,
%     s=['000',int2str(NextT)];
%     l=length(s);
%     s=s((l-3):l);
%     fn=['alphabeta',s,'.eps'];
%     disp(fn)
%     print(h,'-depsc','-loose',fn),
%     NextT=NextT+deltaT;
% end,
            
global movorgif
if movorgif==0,
    global aviobj
    frame = getframe(gca);
    aviobj = addframe(aviobj,frame);
else
%     global gifn
%     gifn=gifn+1;
%     print('-dbmp',['kyotofigs\fig',di(gifn,3),'.bmp'])
end,
% global aviobj,aviobj=close(aviobj)
sys = [];
% End of mdlUpdate.
%
%==============================================================
% mdlOutputs
% Return the block outputs.
%==============================================================
%
%function sys = mdlOutputs(t,x,u,A,B,C,D)
%sys = [];
% End of mdlOutputs.

function sys=mdlTerminate(t,x,u);
global movorgif
if movorgif==0,
    global aviobj,
    aviobj=close(aviobj);
else
%     global gifn
%     disp(['Nombre de frames/gif = ',num2str(gifn)]),
end,
sys=[];
% End of mdlTerminate